import requests
from bitcoinutils.setup import setup
from bitcoinutils.utils import to_satoshis
from bitcoinutils.transactions import Transaction, TxInput, TxOutput
from bitcoinutils.keys import P2pkhAddress, P2shAddress, PrivateKey
from bitcoinutils.script import Script

setup('testnet')

api="https://api.blockcypher.com/v1/btc/test3/addrs/"  

address="2N9dQC4mkYeMw1rEYomehB9VTBXtF4FXqAB"  

#x=requests.get(api + address +"/balance").json()
x=requests.get(api + address).json()
balance=x["balance"]
unconfirmed_balance=x["unconfirmed_balance"]
txinput=x["txrefs"][0]["tx_hash"]
txin_n_out=x["txrefs"][0]["tx_output_n"]

print(txinput, txin_n_out)


txin = TxInput(txinput, txin_n_out)
# hexadecimal obtained with:
# echo "obase=16; 389274691823"|bc|tac -rs ..
unknown_script="EF6894A25A".lower()
to_addr=P2pkhAddress('mrr8vGMehwDj93YM52wGmaQ2ZSTXgSg9Qq')
txout = TxOutput(to_satoshis(0.0137), to_addr.to_script_pub_key() )
redeem_script = Script(["OP_SHA256", "eb2e10773d403f9972939ede70382fc05c43260b1beb0d5163f3b39dbc8f964b", "OP_EQUAL"])
tx = Transaction([txin], [txout])
txin.script_sig = Script([unknown_script, redeem_script.to_hex()])
signed_tx = tx.serialize()
print("\nRaw signed transaction:\n" + signed_tx)
print("\nTxId:", tx.get_txid())

